from common import *;
import texture;

class ACObject:
	"""Represents the 3d Object 
	very minimalistic """
	def __init__( self ):
		self.loc = Normal( );	
		self.name = "";
		self.vertices = [];
		self.surfaces = [];
		self.kids = [];
		self.texture = -1;

	def animate( self ):
		pass;

	def render( self ):
		#vertices of each object
		verts = self.vertices;
	#	glColor3f( .5, .4, .1 );
	#	glColor3f( 1, 1, 1 );
		if self.texture != -1 : 
			glBindTexture( GL_TEXTURE_2D, self.texture );	
		glEnable(GL_ALPHA_TEST);
		glPushMatrix( );
		glTranslatef( self.loc.x, self.loc.y, self.loc.z );
#		glScalef( .5, .5, .5 );
		for surf in self.surfaces:
	  		#vertex refs for each surface
			vrefs = surf.vertref;
			glBegin( GL_TRIANGLES );
			glTexCoord2f( surf.tex[0].x, surf.tex[0].y );
			glNormal3f(	verts[vrefs[0]].normal.x, verts[vrefs[0]].normal.y,	verts[vrefs[0]].normal.z );
			glVertex3f(	verts[vrefs[0]].x, verts[vrefs[0]].y,	verts[vrefs[0]].z );
  		
			glTexCoord2f( surf.tex[1].x, surf.tex[1].y );
			glNormal3f(	verts[vrefs[1]].normal.x, verts[vrefs[1]].normal.y,	verts[vrefs[1]].normal.z );
			glVertex3f(	verts[vrefs[1]].x, verts[vrefs[1]].y,	verts[vrefs[1]].z );
   		
			glTexCoord2f( surf.tex[2].x, surf.tex[2].y );
			glNormal3f(	verts[vrefs[2]].normal.x, verts[vrefs[2]].normal.y,	verts[vrefs[2]].normal.z );
			glVertex3f(	verts[vrefs[2]].x, verts[vrefs[2]].y,	verts[vrefs[2]].z );
			glEnd( );
		for kid in self.kids:
			kid.render( );
		glPopMatrix( );
		glDisable(GL_ALPHA_TEST);

	def readSurf(self):
		self.fp.readline()
		surf=Surface()
		surf.mat=int(self.fp.readline().split()[1])
		numrefs = int(self.fp.readline().split( )[1]);
		for i in xrange(numrefs):
			l=self.fp.readline().split( );
			surf.vertref.append(int(l[0]))
			surf.tex.append(Texture(l[1:]))
			
		surf.normal = self.calcTriNormal( self.vertices[surf.vertref[0]], self.vertices[surf.vertref[1]], self.vertices[surf.vertref[2]] );
		self.surfaces.append( surf );
	
	def readObject( self ):
		while 1:
			line=self.fp.readline()
			ftoken=line.split()[0]
			if ftoken == 'OBJECT':
				pass;
			if ftoken=='name':
				pass;
				
			elif ftoken=='crease':
				pass
				
			elif ftoken=='loc':
				l=line.split()
				l[-1]=l[-1][:-2]
				self.loc.x=float(l[1]);
				self.loc.y=float(l[2]);
				self.loc.z=float(l[3]);
				
			elif ftoken=='texture':
				texfname = line.split( )[-1][1:-1];
				self.texture = texture.loadTexture(texfname)
    
			elif ftoken=='numvert':
				num=int(line.split()[-1])
				for i in xrange(num):
					tmpvertex = Vertex( self.fp.readline( ).split( ) );
					self.vertices.append(tmpvertex)
					
			elif ftoken=='numsurf':
			 	num=int(line.split()[-1])
				for i in xrange(num):
					self.readSurf( );
				self.calcVertNormals( );
					
			elif ftoken=='kids':
			 	num=int(line.split()[-1])
				for i in xrange( num ):
					tmp_obj = ACObject( );
					tmp_obj.fp = self.fp;
					tmp_obj.readObject( );
					self.kids.append( tmp_obj );
				return ;

	
	def calcTriNormal( self, v1, v2, v3 ):
		#caliculating the normal for surface
		len = 0;
		n = Normal( );
		n.x = (v2.y-v1.y)*(v3.z-v1.z)-(v3.y-v1.y)*(v2.z-v1.z);
		n.y = (v2.z-v1.z)*(v3.x-v1.x)-(v3.z-v1.z)*(v2.x-v1.x);
		n.z = (v2.x-v1.x)*(v3.y-v1.y)-(v3.x-v1.x)*(v2.y-v1.y); 
		len = math.sqrt( n.x*n.x + n.y*n.y + n.z*n.z );
		
		if ( len > 0 ):
			n.x /= len;
			n.y /= len;
			n.z /= len;
		return n;
	
	def calcVertNormals( self ):
		#for each vertex in obj
		obj = self;
		for j in xrange(len(obj.vertices)):
			vnormal = Normal( );
			found = 0;
			#for every surface in obj
			for i in xrange( len(obj.surfaces) ):
				surf = obj.surfaces[i];
				#for every vertref in surf
				for itrvar in xrange( len(surf.vertref)):
					if( surf.vertref[itrvar] == j ):
						vnormal.x += surf.normal.x;
						vnormal.y += surf.normal.y;
						vnormal.z += surf.normal.z;
						found += 1;
						
			if found > 0:
				vnormal.x /= found;
				vnormal.y /= found;
				vnormal.z /= found;
			obj.vertices[j].normal = vnormal;
			
	def load( self, objfname ):
		try:
			self.fp = file(objfname,"r");
			line=self.fp.readline();
			while line:
				line=self.fp.readline()
				ftoken=line.split()[0]
				if ftoken=='MATERIAL':
					pass
					
				elif ftoken=='OBJECT':
					self.readObject( );
		except :
			self.fp.close( );

