from OpenGL.GL import *;
from OpenGL.GLU import *;
from Image import open;
import sys;
import math;
import camera;
#import object;

Global_flameTex = [];
Global_smokeTex = 0;
Global_grassTex = 1;
Global_skyTex = 0;
Global_soundList = {};

#hash of models;
Global_ModelArray = {};

#keeps track of the score
Global_scoreCount = 0;
Global_healthIncr = .5;

Global_blueflareTex =0;
Global_flareAmmoTex =0;
Global_rocketAmmoTex =0;
Global_t = 1;

Global_soundEnabled = False;
#this array contains the static objects.
Global_objArray = [];

Global_Camera=camera.CCamera()

#variables to contain ammo related version;
Global_ammoRockets = 10;
Global_ammoFlare = 25;
#you get "flareGun" "rocketGun"
#Global_curGun = "default"
Global_curGun = "flareGun"

#this array contains the moving objects
#have to check collisions for these only
Global_objMovArray = [];

CameraEye = [0, 50, 200];
CameraLook = [ 0, 0, 0 ];
CameraOri = [ 0, 1, 0 ];

#class gameObject:
#	center = [ 0, 0, 0 ];
#	velocity = [ 0, 0, 0 ];
#	type = "tree";
#	culled = False;
#	radius = 50;
#	bbox = [ [-50,0,0], [0,-50,0], [0,0,-50], [50,0,0], [0,50,0], [0,0,50], [0,0,0], [0,0,0] ];
#	def __init__(self, center=[0,0,0], velocity=[0,0,0], type ="tree" ):
#		self.center = center;
#		self.velocity = velocity;
#		self.type = type;
#		self.bbox[0][0] = self.bbox[1][0] = self.center[0] - self.radius;
#		self.bbox[2][0] = self.bbox[3][0] = self.center[0] - self.radius;
#		self.bbox[4][0] = self.bbox[5][0] = self.center[0] + self.radius;
#		self.bbox[6][0] = self.bbox[7][0] = self.center[0] + self.radius;
#		
#		self.bbox[2][1] = self.bbox[3][1] = self.center[1] - self.radius;
#		self.bbox[6][1] = self.bbox[7][1] = self.center[1] - self.radius;
#		self.bbox[0][1] = self.bbox[1][1] = self.center[1] + self.radius;
#		self.bbox[4][1] = self.bbox[5][1] = self.center[1] + self.radius;
#		
#		self.bbox[0][2] = self.bbox[2][2] = self.center[2] - self.radius;
#		self.bbox[4][2] = self.bbox[6][2] = self.center[2] - self.radius;
#		self.bbox[1][2] = self.bbox[3][2] = self.center[2] + self.radius;
#		self.bbox[5][2] = self.bbox[7][2] = self.center[2] + self.radius;
#	
#	def animate(self):
#		pass;
#	
#	def render(self):
#		model = Global_ModelArray[self.type];
#		model.loc.x = self.center[0];
#		model.loc.y = self.center[1];
#		model.loc.z = self.center[2];
#
#		if( self.type == "pplant" ):
#			glColor3f( 1, 1, 1 );
#		model.render( );
#		
#		if self.type == "tree":
#			tmp = Global_ModelArray['leaves'];
#			tmp.loc.x = self.center[0];
#			tmp.loc.y = self.center[1];
#			tmp.loc.z = self.center[2];
#			tmp.render( );

class Normal:
	def __init__( self ):
		self.x = 0;
		self.y = 0;
		self.z = 0;

class Vertex:
	def __init__( self , V=[0,0,0]):
		self.x = float(V[0]);
		self.y = float(V[1]);
		self.z = float(V[2]);
		self.normal = Normal( );

class Texture:
	"""Represents the texture coordinates
	in the AC3D object. """
	def __init__( self,l=[0,0] ):
		self.x = float(l[0]);
		self.y = float(l[1]);

class Surface:
	"""Represents the surfaces in the
		AC3D object """
	def __init__( self ):
		self.vertref= [];
		self.tex= [];
		self.normal = Normal( );
		self.mat = 0;

#setup for drawing in 2D
def view2D( width = 640, height = 480 ):
	#glDepthMask(0);
	glDisable(GL_DEPTH_TEST);
	glViewport( 0, 0, 640, 480 );
	glMatrixMode( GL_PROJECTION );
	glLoadIdentity( );
	glOrtho( -100*1.33, 100*1.33, -100, 100, -100, 100 );
	glMatrixMode( GL_MODELVIEW );
	glLoadIdentity( );

#setup for drawing 3D world
def view3D( ):
	#glDepthMask(1);
	glEnable(GL_DEPTH_TEST);
	glViewport( 0, 0, 640, 480 );
	glMatrixMode( GL_PROJECTION );
	glLoadIdentity( );
	gluPerspective( 45, 640.0/480.0, 0.1, 600 ); 
	glMatrixMode( GL_MODELVIEW );
	glLoadIdentity( );
	Global_Camera.Look()
	#gluLookAt( CameraEye[0], CameraEye[1], CameraEye[2], CameraLook[0], CameraLook[1], CameraLook[2], CameraOri[0], CameraOri[1], CameraOri[2] );


def RAD(theta):
	return theta*math.pi/180.0;

def BuildRotMatrix( theta, x, y, z ):
	m = [1,0,0,0, 0,1,0,0, 0,0,1,0, 0,0,0,1 ];
	d = x*x + y*y + z*z;
	ct = math.cos(RAD(theta));
	st = math.sin(RAD(theta));
	if (d > 0):
		d = 1/d;
		x *= d;
		y *= d;
		z *= d;
#	m[0] = 1; m[1] = 0; m[2] = 0; m[3] = 0;
#	m[4] = 0; m[5] = 1; m[6] = 0; m[7] = 0;
#	m[8] = 0; m[9] = 0; m[10] = 1; m[11] = 0;
#	m[12] = 0; m[13] = 0; m[14] = 0; m[15] = 1;

# * R = uu' + cos(theta)*(I-uu') + sin(theta)*S
# *
# * S =  0  -z   y    u' = (x, y, z)
# *      z   0  -x
# *     -y   x   0
# *
	m[0] = x*x + ct*(1-x*x) + st*0;
	m[4] = x*y + ct*(0-x*y) + st*-z;
	m[8] = x*z + ct*(0-x*z) + st*y;

	m[1] = y*x + ct*(0-y*x) + st*z;
	m[5] = y*y + ct*(1-y*y) + st*0;
	m[9] = y*z + ct*(0-y*z) + st*-x;

	m[2] = z*x + ct*(0-z*x) + st*-y;
	m[6] = z*y + ct*(0-z*y) + st*x;
	m[10]= z*z + ct*(1-z*z) + st*0;

	return m;

#setup for the sprite
def viewSprite( ):
	mat = glGetFloatv( GL_MODELVIEW_MATRIX );
	m = BuildRotMatrix( 180*math.atan2(mat[0][2], mat[2][2])/math.pi, 0, 1, 0 );
	glMultMatrixf(m);
	
