from OpenGL.GL import *;
from OpenGL.GLU import *;
import common;

class Flame:
	x = y = z = 0;	
	cur_frame = 0;
	max_frames = 14;

	def __init__( self, x, y, z, height=40 ):
		self.cur_frame = 0;
		self.x = x;
		self.y = y;
		self.z = z;
		self.height = height;
	
	def render( self ):
		glDepthMask(0);
		glBindTexture(GL_TEXTURE_2D, common.Global_flameTex[self.cur_frame]);
#		glPushMatrix( );
#		glTranslatef( self.x, self.y, self.z );
#		glBegin(GL_QUADS);
#		glTexCoord2f(0, 0); glVertex3f(-15.,-15., -0.);
#		glTexCoord2f(0, 1); glVertex3f(-15., 15.,  0.);
#		glTexCoord2f(1, 1);	glVertex3f( 15., 15.,  0.);
#		glTexCoord2f(1, 0);	glVertex3f( 15.,-15., -0.);
#		glEnd();

		glBegin(GL_POLYGON);
		glTexCoord2f( 0, 0 ); glVertex3f( -(self.height/2), 0, 0);
		glTexCoord2f( 1, 0 ); glVertex3f( self.height/2, 0, 0 );
		glTexCoord2f( 1, 1 ); glVertex3f( self.height/2, self.height, 0 );
		glTexCoord2f( 0, 1 ); glVertex3f( -(self.height/2), self.height, 0 );
		glEnd( );
		glDepthMask(1);
#		glPopMatrix( );
		
	def animate(self):
		self.cur_frame += 1;
		if( self.cur_frame >= self.max_frames ):
			self.cur_frame = 0;
