from OpenGL.GL import *;
from OpenGL.GLU import *;
from OpenGL.GLUT import *;
import math;
import pygame;
import texture;
import sys;


def nextpow2( x ):
	logbase2 = math.log(x)/math.log(2);
	return int(math.pow(2,math.ceil(logbase2))+0.5);

def fntId( fntname, size, text, color = ( 0, 0, 0 )):
	fnt = pygame.font.Font(fntname, size );
	surface = fnt.render( text, 1, color );
	x = nextpow2(surface.w);
	y = nextpow2(surface.h);
	newsurf = pygame.Surface( (x, y) );
	newsurf.blit(surface);

	texid = glGenTextures(1);
	glBindTexture(GL_TEXTURE_2D, texture);

	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_CLAMP);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_CLAMP);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA8, w, h, 0, GL_BGRA, GL_UNSIGNED_BYTE, nusurf.pixels );

	return texid;

	

class Font:
	def __init__(self, texname="textures/Font.tga"):
		self.texture = texture.loadTexture(texname);
		self.FTW = .125;
		self.FTH = .156;
		#/defining the texture coords
		#/All capital letters
		self.FontTexCoords ={};

		self.FontTexCoords['A'] = [0,0];
		self.FontTexCoords['A'][0] = 0;	
		self.FontTexCoords['A'][1] = 0;	

		self.FontTexCoords['B']= [0,0];
		self.FontTexCoords['B'][0] = self.FTW;
		self.FontTexCoords['B'][1] = 0;	

		self.FontTexCoords['C']= [0,0];
		self.FontTexCoords['C'][0] = 2*self.FTW;
		self.FontTexCoords['C'][1] = 0;	
		self.FontTexCoords['D']= [0,0];
		self.FontTexCoords['D'][0] = 3*self.FTW;
		self.FontTexCoords['D'][1] = 0;	
		self.FontTexCoords['E']= [0,0];
		self.FontTexCoords['E'][0] = 4*self.FTW;
		self.FontTexCoords['E'][1] = 0;	
		self.FontTexCoords['F']= [0,0];
		self.FontTexCoords['F'][0] = 5*self.FTW;
		self.FontTexCoords['F'][1] = 0;	
		self.FontTexCoords['G']= [0,0];
		self.FontTexCoords['G'][0] = 6*self.FTW;
		self.FontTexCoords['G'][1] = 0;	
		self.FontTexCoords['H']= [0,0];
		self.FontTexCoords['H'][0] = 0*self.FTW;
		self.FontTexCoords['H'][1] = 1*self.FTH;
		self.FontTexCoords['I']= [0,0];
		self.FontTexCoords['I'][0] = 1*self.FTW;
		self.FontTexCoords['I'][1] = 1*self.FTH;
		self.FontTexCoords['J']= [0,0];
		self.FontTexCoords['J'][0] = 2*self.FTW;
		self.FontTexCoords['J'][1] = 1*self.FTH;
		self.FontTexCoords['K']= [0,0];
		self.FontTexCoords['K'][0] = 3*self.FTW;
		self.FontTexCoords['K'][1] = 1*self.FTH;
		self.FontTexCoords['L']= [0,0];
		self.FontTexCoords['L'][0] = 4*self.FTW;
		self.FontTexCoords['L'][1] = 1*self.FTH;
		self.FontTexCoords['M']= [0,0];
		self.FontTexCoords['M'][0] = 5*self.FTW;
		self.FontTexCoords['M'][1] = 1*self.FTH;
		self.FontTexCoords['N']= [0,0];
		self.FontTexCoords['N'][0] = 6*self.FTW;
		self.FontTexCoords['N'][1] = 1*self.FTH;
		self.FontTexCoords['O']= [0,0];
		self.FontTexCoords['O'][0] = 0*self.FTW;
		self.FontTexCoords['O'][1] = 2*self.FTH;
		self.FontTexCoords['P']= [0,0];
		self.FontTexCoords['P'][0] = 1*self.FTW;
		self.FontTexCoords['P'][1] = 2*self.FTH;
		self.FontTexCoords['Q']= [0,0];
		self.FontTexCoords['Q'][0] = 2*self.FTW;
		self.FontTexCoords['Q'][1] = 2*self.FTH;
		self.FontTexCoords['R']= [0,0];
		self.FontTexCoords['R'][0] = 3*self.FTW;
		self.FontTexCoords['R'][1] = 2*self.FTH;
		self.FontTexCoords['S']= [0,0];
		self.FontTexCoords['S'][0] = 4*self.FTW;
		self.FontTexCoords['S'][1] = 2*self.FTH;
		self.FontTexCoords['T']= [0,0];
		self.FontTexCoords['T'][0] = 5*self.FTW;
		self.FontTexCoords['T'][1] = 2*self.FTH;
		self.FontTexCoords['U']= [0,0];
		self.FontTexCoords['U'][0] = 6*self.FTW;
		self.FontTexCoords['U'][1] = 2*self.FTH;
		self.FontTexCoords['V']= [0,0];
		self.FontTexCoords['V'][0] = 0*self.FTW;
		self.FontTexCoords['V'][1] = 3*self.FTH;
		self.FontTexCoords['W']= [0,0];
		self.FontTexCoords['W'][0] = 1*self.FTW;
		self.FontTexCoords['W'][1] = 3*self.FTH;
		self.FontTexCoords['X']= [0,0];
		self.FontTexCoords['X'][0] = 2*self.FTW;
		self.FontTexCoords['X'][1] = 3*self.FTH;
		self.FontTexCoords['Y']= [0,0];
		self.FontTexCoords['Y'][0] = 3*self.FTW;
		self.FontTexCoords['Y'][1] = 3*self.FTH;
		self.FontTexCoords['Z']= [0,0];
		self.FontTexCoords['Z'][0] = 4*self.FTW;
		self.FontTexCoords['Z'][1] = 3*self.FTH;

		#/numbers
		self.FontTexCoords['1']= [0,0];
		self.FontTexCoords['1'][0] = 5*self.FTW;
		self.FontTexCoords['1'][1] = 3*self.FTH;
		self.FontTexCoords['2']= [0,0];
		self.FontTexCoords['2'][0] = 6*self.FTW;
		self.FontTexCoords['2'][1] = 3*self.FTH;
		self.FontTexCoords['3']= [0,0];
		self.FontTexCoords['3'][0] = 0*self.FTW;
		self.FontTexCoords['3'][1] = 4*self.FTH;
		self.FontTexCoords['4']= [0,0];
		self.FontTexCoords['4'][0] = 1*self.FTW;
		self.FontTexCoords['4'][1] = 4*self.FTH;
		self.FontTexCoords['5']= [0,0];
		self.FontTexCoords['5'][0] = 2*self.FTW;
		self.FontTexCoords['5'][1] = 4*self.FTH;
		self.FontTexCoords['6']= [0,0];
		self.FontTexCoords['6'][0] = 3*self.FTW;
		self.FontTexCoords['6'][1] = 4*self.FTH;
		self.FontTexCoords['7']= [0,0];
		self.FontTexCoords['7'][0] = 4*self.FTW;
		self.FontTexCoords['7'][1] = 4*self.FTH;
		self.FontTexCoords['8']= [0,0];
		self.FontTexCoords['8'][0] = 5*self.FTW;
		self.FontTexCoords['8'][1] = 4*self.FTH;
		self.FontTexCoords['9']= [0,0];
		self.FontTexCoords['9'][0] = 6*self.FTW;
		self.FontTexCoords['9'][1] = 4*self.FTH;
		self.FontTexCoords['0']= [0,0];
		self.FontTexCoords['0'][0] = 0*self.FTW;
		self.FontTexCoords['0'][1] = 5*self.FTH;
		
		#/special chars
		self.FontTexCoords[' ']= [0,0];
		self.FontTexCoords[' '][0] = 1*self.FTW;
		self.FontTexCoords[' '][1] = 5*self.FTH;
		self.FontTexCoords['-']= [0,0];
		self.FontTexCoords['-'][0] = 2*self.FTW;
		self.FontTexCoords['-'][1] = 5*self.FTH;
		self.FontTexCoords['!']= [0,0];
		self.FontTexCoords['!'][0] = 3*self.FTW;
		self.FontTexCoords['!'][1] = 5*self.FTH;
		self.FontTexCoords[':']= [0,0];
		self.FontTexCoords[':'][0] = 4*self.FTW;
		self.FontTexCoords[':'][1] = 5*self.FTH;
		self.FontTexCoords['?']= [0,0];
		self.FontTexCoords['?'][0] = 5*self.FTW;
		self.FontTexCoords['?'][1] = 5*self.FTH;
		self.FontTexCoords['&']= [0,0];
		self.FontTexCoords['&'][0] = 6*self.FTW;
		self.FontTexCoords['&'][1] = 6*self.FTH;

#	def __init__(self, texname="textures/font.tga", ):
#		self.texture = texture.loadTexture(texname);
#		self.FontTexture={};
#		self.FontTexture['.']=[.625,.625];
#		self.FontTexture['?']=[.742,.875];
#		self.FontTexture['#']=[.25,.5];
#		self.FontTexture[' ']=[.875,.875];
#		self.FontTexture['0']=[.875,.625];
#		self.FontTexture['1']=[.0,.75];
#		self.FontTexture['2']=[.117,.75];
#		self.FontTexture['3']=[.25,.75];
#		self.FontTexture['4']=[.367,.75];
#		self.FontTexture['5']=[.5,.75];
#		self.FontTexture['6']=[.625,.75];
#		self.FontTexture['7']=[.742,.75];
#		self.FontTexture['8']=[.875,.75];
#		self.FontTexture['9']=[.0,.875];
#		self.FontTexture[':']=[.125,.875];
#
#		self.FontTexture['A']=[0,0];
#		self.FontTexture['B']=[.117,0];
#		self.FontTexture['C']=[.25,0];
#		self.FontTexture['D']=[.367,0];
#		self.FontTexture['E']=[.5,0];
#		self.FontTexture['F']=[.625,0];
#		self.FontTexture['G']=[.742,0];
#		self.FontTexture['H']=[.875,0];
#		self.FontTexture['I']=[.0,.125];
#		self.FontTexture['J']=[.117,.125];
#		self.FontTexture['K']=[.25,.125];
#		self.FontTexture['L']=[.367,.125];
#		self.FontTexture['M']=[.5,.125];
#		self.FontTexture['N']=[.625,.125];
#		self.FontTexture['O']=[.742,.125];
#		self.FontTexture['P']=[.875,.125];
#		self.FontTexture['Q']=[.0,.25];
#		self.FontTexture['R']=[.117,.25];
#		self.FontTexture['S']=[.25,.25];
#		self.FontTexture['T']=[.367,.25];
#		self.FontTexture['U']=[.5,.25];
#		self.FontTexture['V']=[.625,.25];
#		self.FontTexture['W']=[.742,.25];
#		self.FontTexture['X']=[.875,.25];
#		self.FontTexture['Y']=[0,.375];
#		self.FontTexture['Z']=[.117,.375];

	def drawString( self, str, x, y, fwidth, fheight ):
		add_x = 10.0/128.0;
		add_y = 15.0/128.0;
		loopvar = 0;
		limit = len(str);	
		if limit == 0:
			return;
	
		glBindTexture( GL_TEXTURE_2D, self.texture );		
		for i in xrange(limit):
			glBegin( GL_POLYGON );
			glTexCoord2f( self.FontTexCoords[str[i]][0], 1-self.FontTexCoords[str[i]][1] );
			glVertex2f( i*fwidth+x, y );
			glTexCoord2f( self.FontTexCoords[str[i]][0]+self.FTW, 1-self.FontTexCoords[str[i]][1] );
			glVertex2f( x+(i+1)*fwidth, y );		
			glTexCoord2f( self.FontTexCoords[str[i]][0]+self.FTW, 1-self.FontTexCoords[str[i]][1]-self.FTH );
			glVertex2f( x+(i+1)*fwidth, y-fheight );		
			glTexCoord2f( self.FontTexCoords[str[i]][0], 1-self.FontTexCoords[str[i]][1]-self.FTH );
			glVertex2f( i*fwidth+x, y-fheight );		
			glEnd( );

#			glColor3f( 1, 0, 0 );
#			glBegin( GL_POLYGON );
#			glVertex2f( x+loopvar*font_width, y );
#			glVertex2f( x+(loopvar+1)*font_width, y );
#			glVertex2f( x+(loopvar+1)*font_width, y+font_height );
#			glVertex2f( x+loopvar*font_width, y+font_height );
#			glEnd( );
#			glBegin( GL_POLYGON );
#			glTexCoord2f( self.FontTexture[str[loopvar]][0],self.FontTexture[str[loopvar]][1] );
#			glVertex2f( x + loopvar*font_width, y + font_height );
#			
#			glTexCoord2f( self.FontTexture[str[loopvar]][0],self.FontTexture[str[loopvar]][1] + add_y );
#			glVertex2f( x + loopvar*font_width, y );
#			
#			glTexCoord2f( self.FontTexture[str[loopvar]][0] + add_x ,self.FontTexture[str[loopvar]][1] + add_y );
#			glVertex2f( x + loopvar*font_width + font_width , y);
#
#			glTexCoord2f( self.FontTexture[str[loopvar]][0] + add_x ,self.FontTexture[str[loopvar]][1] );
#			glVertex2f( x + loopvar*font_width + font_width, y+font_height );
#			glEnd( );

