from OpenGL.GL import *;
from OpenGL.GLU import *;
import math;
import random;
import sys;
import common;

class elem:
	x = y = z = 0;
	dx = dy = dz = 0;
	size = 0;
	ts = 0;
	opacity = 0;

	def __init__(self):
		self.dx = random.randrange(20);
		self.dy = random.randrange(10);
		self.dz = random.randrange(20);
	
class Smoke:
	ox = oy = oz = 0;
	dx = dy = dz = 0;
	elems = [];
	intensity = 0;
	min_size = 0.2;
	max_size = 1.0;
	texture = 0;

	def __init__(self, x, y, z, dx, dy, dz, elems, intensity, texture ):
		self.ox = x;
		self.oy = y;
		self.oz = z;
		self.dx = dx;
		self.dy = dy;
		self.dz = dz;
		self.intesity = intensity;
		self.texture = texture;
		for i in xrange(elems):
			tmp = elem();
			tmp.ts = i/float(elems);
			self.elems.append(tmp);

	def render(self):
		glDepthMask(0);
		#glBindTexture(GL_TEXTURE_2D, self.texture);
		glBindTexture(GL_TEXTURE_2D, common.Global_smokeTex );
		glEnable(GL_ALPHA_TEST);
		glDisable(GL_LIGHTING);
		for i in xrange(len(self.elems)):
			e = self.elems[i];
			glColor4f(self.intensity,self.intensity,self.intensity,e.opacity);
			glBegin(GL_QUADS);
			glTexCoord2f(0, 0); 
			glVertex3f(-15*e.size+e.x,-15*e.size+e.y, -0.+e.z);
			glTexCoord2f(0, 1); 
			glVertex3f(-15*e.size+e.x, 15*e.size+e.y,  0.+e.z);
			glTexCoord2f(1, 1);	
			glVertex3f( 15.*e.size+e.x, 15*e.size+e.y,  0.+e.z);
			glTexCoord2f(1, 0);	
			glVertex3f( 15.*e.size+e.x,-15.*e.size+e.y, -0.+e.z);
			glEnd();
		glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
		glDepthMask(1);
		glEnable(GL_LIGHTING);
		glDisable(GL_ALPHA_TEST);
	    
		
	def animate(self, tick ):
		for i in xrange(len(self.elems)):
			e = self.elems[i];
			e.ts += tick;
			if e.ts >= 1.0:
				e.ts = 0;
			#e.x = float(self.ox + self.dx * e.ts + e.dx * e.ts);
			e.x = float( e.dx * e.ts);
			e.y = float(self.dy * e.ts + e.dy * e.ts);
			#e.y = float( e.dy * e.ts);
			#e.z = float(self.oz + self.dz * e.ts + e.dz * e.ts);
			e.z = float( e.dz * e.ts);
			e.size = float(self.min_size + e.ts * self.max_size);
			e.opacity = (1.0-e.ts);

Global_SmokeVar = Smoke( 0, 0, 0, 0, 40, 0, 10, 0.4, common.Global_smokeTex );
